package usherbrooke.ift630;

import java.lang.Long;
import java.util.ArrayList;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.Executors;
import java.util.concurrent.ExecutorService;
/**
 * Hello world!
 *
 */
public class App {
	static private int numStops				= 10;
	static private int numBusses			= 5;
	static private int numStopPerBus		= 2;
	static private int numPassengersPerBus	= 2;
	static private int numPassengersPerStop	= 5;
	static private int numPassengers		= numPassengersPerStop * numStops;
	static private int numThreads			= 5;
	static private int timeBetweenStops		= 0;
	static private int timeEmbark			= 0;

    public static void main(String[] args) {
		ExecutorService threads =			Executors.newFixedThreadPool(numThreads);
		ArrayList<Stop> stops =				new ArrayList<Stop>();
		ArrayList<Bus> busses =				new ArrayList<Bus>();
		ArrayList<Passenger> passengers =	new ArrayList<Passenger>();

		for (int k = 0; k < numStops; k++) {
			Stop s = new Stop(k, numPassengersPerStop);
			stops.add(s);

			//threads.submit(s);
		}

		for (int k = 0; k < numBusses; k++) {
			ArrayList<Stop> s_list = new ArrayList<Stop>();
			Stop s;
			while (s_list.size() < numStopPerBus) {
				do {
					s = stops.get((int) (Math.random() * numStops));
				} while (s_list.contains(s));
				s_list.add(s);
			}
			Bus b = new Bus(s_list, k, timeBetweenStops, timeEmbark, numPassengersPerBus);

			busses.add(b);
		}

		int idPassenger = 0;
		for (Bus b : busses) {
			for (Stop start : b.getStops()) {
				if (start == b.getTerminus()) 
					continue;

				int idx = b.getStops().indexOf(start);
				if (idx == -1 || start == b.getTerminus())
					continue;

				for (int k = 0; k < (int) (Math.random() * numPassengersPerStop); k++) {
					Stop dest = null;

					dest = b.getStops().get(idx + 1 + (int) Math.round(Math.random() * (numStopPerBus - 2 - idx)));

					Passenger p = new Passenger(idPassenger, start, dest);
					passengers.add(p);
					start.addPassenger(p);
					idPassenger++;
				}
			}
		}

		for (Bus b : busses) {
			b.printDetails();
		}


		// start bus thread
		// (here so init logs are clean)
		for (Bus b : busses) {
			threads.submit(b);
			//b.run();
		}

		threads.shutdown();

		try {
			threads.awaitTermination(Long.MAX_VALUE, TimeUnit.DAYS);
		} catch (InterruptedException e) {}
	}
}
